package com.smg.persistwork.exception;

/**
 * Tractament de les excepcions al Framework
 * de Persistncia
 * @author Sergio Maeso
 * @version 1.0
 */
public class PersistWorkException extends Exception{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/*
	 * Classificaci dels missatges per tipus
	 * BD: paquet base de dades
	 * NUC: paquet nucli
	 * MAP: paquet mapeig
	 */
	public static final int BD_1 = 101;
	public static final int BD_2 = 102;
	public static final int BD_3 = 103;
	public static final int BD_4 = 104;
	public static final int BD_5 = 105;
	public static final int BD_6 = 106;	
	public static final int BD_7 = 107;
	public static final int BD_8 = 108;
	public static final int BD_9 = 109;
	public static final int BD_10 = 110;
	public static final int BD_11 = 110;
	
	public static final int NUC_1 = 201;
	public static final int NUC_2 = 202;
	public static final int NUC_3 = 203;
	public static final int NUC_4 = 204;
	public static final int NUC_5 = 205;
	public static final int NUC_6 = 206;	
	public static final int NUC_7 = 207;
	public static final int NUC_8 = 208;
	public static final int NUC_9 = 209;
	public static final int NUC_10 = 210;
	public static final int NUC_11 = 211;
	public static final int NUC_12 = 212;
	
	public static final int MAP_1 = 301;
	public static final int MAP_2 = 302;
	public static final int MAP_3 = 303;
	public static final int MAP_4 = 304;
	public static final int MAP_5 = 305;
	public static final int MAP_6 = 306;	
	public static final int MAP_7 = 307;
	public static final int MAP_8 = 308;
	public static final int MAP_9 = 309;
	public static final int MAP_10 = 310;
	
	public static final String BD1_TXT = "No s'ha pogut realitzar la connexi";
	public static final String BD2_TXT = "No s'ha pogut tancar la connexi";
	public static final String BD3_TXT = "No s'ha pogut realitzar el rollback";
	public static final String BD4_TXT = "No s'ha pogut iniciar la transacci";
	public static final String BD5_TXT = "No s'ha pogut realitzar la sentncia";
	public static final String BD6_TXT = "No s'ha pogut realitzar la sentncia que retorna dades";	
	public static final String BD7_TXT = "No s'ha pogut realitzar la sentncia amb parmetres";
	public static final String BD8_TXT = "No hi ha connexi disponible";
	public static final String BD9_TXT = "No s'ha pogut generar el PreparedStatement";
	public static final String BD10_TXT = "No s'ha pogut realitzar la sentncia que retorna dades";	
	public static final String BD11_TXT = "No s'ha pogut inicialitzar la connexi de forma correcta";	
	
	public static final String NUC1_TXT = "Nmero de parmetres incorrectes";
	public static final String NUC2_TXT = "No s'ha pogut carregar el fitxer de configuraci";
	public static final String NUC3_TXT = "No s'ha pogut trobar la classe";
	public static final String NUC4_TXT = "No s'ha pogut crear la instncia de la classe";
	public static final String NUC5_TXT = "No s'ha pogut accedir al mtode de forma correcta";
	public static final String NUC6_TXT = "Error de camp que t valor null";	
	public static final String NUC7_TXT = "S'ha produt una excepci no controlada";
	public static final String NUC8_TXT = "Error d'accs a dades";
	public static final String NUC9_TXT = "No s'ha trobat el mtode";
	public static final String NUC10_TXT = "Tipus d'argument incorrecte";	
	public static final String NUC11_TXT = "Invocaci del mtode incorrecte";	
	public static final String NUC12_TXT = "Falta la clau primria per a realitzar la cerca";	
		
	public static final String MAP1_TXT = "No s'ha pogut trobar la equivalncia correcta";
	public static final String MAP2_TXT = "No s'ha trobat el camp";
	public static final String MAP3_TXT = "Tipus d'argument incorrecte";
	public static final String MAP4_TXT = "No s'ha pogut crear la instncia de la classe";
	public static final String MAP5_TXT = "No s'ha pogut accedir al mtode de forma correcta";
	public static final String MAP6_TXT = "No s'ha trobat el mtode";	
	public static final String MAP7_TXT = "Invocaci del mtode incorrecte";
	public static final String MAP8_TXT = "Error d'accs a base de dades";
	public static final String MAP9_TXT = "No s'ha trobat l'anotaci de taula";
	public static final String MAP10_TXT = "Tipus no soportat";	

	/**
	 * Codi de l'error produt.
	 */
	private int codiError;	
	
	/**
	 * Missatge d'error associat a la excepci.
	 */
	private String missatgeError;
	
	/**
	 * Creaci d'una excepci del framework de persistncia.
	 * @param codiError
	 * @param missatgeError
	 */
	public PersistWorkException(int codiError, String missatgeError) {
		super();
		this.codiError = codiError;
		this.missatgeError = missatgeError;
	}
	
	/**
	 * Retornar el missatge que ha produt la excepci, aix como informaci
	 * de la pila.
	 * @return missatge d'error
	 */
	public String getPilaMissatge(){
		
		StringBuilder st = new StringBuilder();
		st.append("Codi Error: " ).append(codiError).append(". Missatge error: ").append(missatgeError).append("\r\n");
		StackTraceElement[] pilaError = this.getStackTrace();
		for (StackTraceElement error : pilaError){
			st.append("Classe: ").append(error.getClassName()).append(".").append(error.getMethodName()).append("(").append(error.getFileName());
			st.append(": Linia : ").append(error.getLineNumber()).append(")").append("\r\n");
		}		
		
		return st.toString();
	}
	
	/**
	 * Retornar el missatge que ha produt la excepci.
	 * @return missatge d'error
	 */
	public String getMissatge(){
		
		StringBuilder st = new StringBuilder();
		st.append("Codi Error: " ).append(codiError).append(". Missatge error: ").append(missatgeError);
	
		
		return st.toString();
	}
}
