package com.smg.persistwork.model.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;


/**
 * Anotaci per a indicar que una columna s 
 * clau foranea d'una altra taula.
 * @author Sergio Maeso
 * @version 1.0
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.FIELD})
public @interface ClauForanea {
	
	/**
	 * Nom de la clau foranea.
	 * @return nom de la clau forenea
	 */
	public String nomClauForana() default "";
	
	/**
	 * Nom del camp que s clau foranea.
	 * @return nom del camp
	 */
	public String nomCamp() default "";
	
	/**
	 * Retornar si s obligatori o no null.
	 * @return obligatori
	 */
	public boolean obligatori() default false;
	

}
