package com.smg.persistwork.model.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Anotaci per a indicar que un camp s clau primaria
 * @author Sergio Maeso
 * @version 1.0
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.FIELD})
public @interface ClauPrimaria {

	/**
	 * Retornar el tipus de clau.
	 * @return tipus de clau primria
	 */
	public TipusClau tipusClau() default TipusClau.VALOR_ASSIGNAT;
	
	/**
	 * Retornar el nom de la seqncia, en cas
	 * que s'hagi d'assignar el valor de forma incremental.
	 * @return nom seqencia.
	 * 
	 */
	public String nomSequencia() default "";
}
