package com.smg.persistwork.model.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Anotaci per a identificar que una classe es mapejar a una taula.
 * @author Sergio Maeso
 *
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.TYPE)
public @interface Taula {

	/**
	 * Identificar el nom de la taula a la qual s'ha de mapejar la entitat. 
	 * No s obligatori si el nom de la entitat s igual a la taula de la
	 * base de dades.
	 * @return nom taula
	 */
	String nom() default "";
	

}
