package com.smg.persistwork.model.mapeig;

import java.util.HashMap;
import java.util.Map;

/**
 * Factoria per a guardar diferents registres d'objectes, en cas que es
 * tingui diferents entorns.
 * @author Sergio Maeso
 * @version 1.0
 */
public class RegistreObjectesFactory {

	/**
	 * Registre de registre d'objectes.
	 */
	private static Map<String, RegistreObjectes> registres;

	/**
	 * Id per defecte del registre per defecte
	 */
	private static String ID_DEFECTE = "RegistreObjectesFactory.ID";

	/**
	 * Es retornar el registre d'objectes
	 * @param id
	 * @return RegistreObjectes
	 */
	public static RegistreObjectes getRegistre(String id) {

		if (registres == null) {
			registres = new HashMap<String, RegistreObjectes>();
		}
		if (id == null)
			id = ID_DEFECTE;
		if (!registres.containsKey(id)) {
			RegistreObjectes regobj = new RegistreObjectes(id);
			registres.put(id, regobj);
		}

		return registres.get(id);
	}
}
