package com.smg.persistwork.nucli;

import com.smg.persistwork.exception.PersistWorkException;

/**
 * Factoria per a crear manegadors d'entitats.
 * @author Sergio Maeso
 * @version 1.0
 *
 */
public class ManegadorEntitatFactory {

	
	/**
	 * Crear un manegador d'entitats amb l'entorn per defecte.
	 * @return ManegadorEntitat
	 * @throws PersistWorkException 
	 */
	public static ManegadorEntitat createManegadorEntitat() throws PersistWorkException{
		
		return new ManegadorEntitat();
	}
	
	/**
	 * Crear un manegador d'entitat modificant l'entorn.
	 * @return ManegadorEntitat
	 * @throws PersistWorkException 
	 */
	public static ManegadorEntitat createManegadorEntitat(String id, String fitxer) throws PersistWorkException{
		
		return new ManegadorEntitat(id, fitxer);
	}
}
