package com.smg.persistwork.aplicacio.model;

import java.math.BigDecimal;
import java.util.Date;
import java.util.GregorianCalendar;

import com.smg.persistwork.model.annotations.ClauForanea;
import com.smg.persistwork.model.annotations.ClauPrimaria;
import com.smg.persistwork.model.annotations.Columna;
import com.smg.persistwork.model.annotations.Taula;
import com.smg.persistwork.model.annotations.TipusClau;

@Taula(nom="EMPLEATS_TEST")
public class EmpleadoTest {

	@Columna(tamany=30,valorDefecte="USUARI")
	private String nom;
	
	@Columna(tamany=12, obligatori=true, valorDefecte="5")
	private int id;

	@Columna(nom="idllarg", tamany=30, obligatori=true, valorDefecte="1000")
	private long id2;
	
	@Columna(tamany=10, nom="ID", obligatori=true)	
	@ClauPrimaria(tipusClau=TipusClau.AUTO_INCREMENT,nomSequencia="SEQ_EMPLEATS_TEST")
	private Integer id3;
	
	@Columna(nom="paga", tamany=30)
	private Long id4;
	
	@Columna(tamany=12, precisio=2, obligatori=true, valorDefecte="0.5")	
	private double id5;

	@Columna(nom="idllarg2", precisio=20, tamany=30, obligatori=true, valorDefecte="1000")
	private float id6;
	
	@Columna(tamany=20, nom="sueldo2", precisio=13, obligatori=true, valorDefecte="100")	
	private Double id7;
	
	@Columna(nom="paga3", tamany=30)
	private Float id8;
	
	@Columna(nom="paga4", tamany=30, precisio=14,obligatori=true, valorDefecte="1112.56")
	private BigDecimal bd;
	
	@Columna(nom="dataAlta")
	private Date data;
	
	@Columna(nom="dataVacaciones", obligatori=true, valorDefecte="SYSDATE")
	private GregorianCalendar data2;
	
	@ClauForanea(nomCamp="idAdmin", nomClauForana="FK_ADMI_TEST" , obligatori=true)
	private AdministracionTest admin;
	
	public EmpleadoTest() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param nom
	 * @param id
	 * @param id2
	 * @param id3
	 * @param id4
	 * @param id5
	 * @param id6
	 * @param id7
	 * @param id8
	 * @param bd
	 * @param data
	 * @param data2
	 * @param admin
	 */
	public EmpleadoTest(String nom, int id, long id2, Integer id3, Long id4,
			double id5, float id6, Double id7, Float id8, BigDecimal bd,
			Date data, GregorianCalendar data2, AdministracionTest admin) {
		super();
		this.nom = nom;
		this.id = id;
		this.id2 = id2;
		this.id3 = id3;
		this.id4 = id4;
		this.id5 = id5;
		this.id6 = id6;
		this.id7 = id7;
		this.id8 = id8;
		this.bd = bd;
		this.data = data;
		this.data2 = data2;
		this.admin = admin;
	}

	public AdministracionTest getAdmin() {
		return admin;
	}

	public void setAdmin(AdministracionTest admin) {
		this.admin = admin;
	}

	public long getId2() {
		return id2;
	}

	public void setId2(long id2) {
		this.id2 = id2;
	}

	public Integer getId3() {
		return id3;
	}

	public void setId3(Integer id3) {
		this.id3 = id3;
	}

	public Long getId4() {
		return id4;
	}

	public void setId4(Long id4) {
		this.id4 = id4;
	}

	public double getId5() {
		return id5;
	}

	public void setId5(double id5) {
		this.id5 = id5;
	}

	public float getId6() {
		return id6;
	}

	public void setId6(float id6) {
		this.id6 = id6;
	}

	public Double getId7() {
		return id7;
	}

	public void setId7(Double id7) {
		this.id7 = id7;
	}

	public Float getId8() {
		return id8;
	}

	public void setId8(Float id8) {
		this.id8 = id8;
	}

	public BigDecimal getBd() {
		return bd;
	}

	public void setBd(BigDecimal bd) {
		this.bd = bd;
	}

	public Date getData() {
		return data;
	}

	public void setData(Date data) {
		this.data = data;
	}

	public GregorianCalendar getData2() {
		return data2;
	}

	public void setData2(GregorianCalendar data2) {
		this.data2 = data2;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}
	
}
