package com.smg.persistwork.model;

import static org.junit.Assert.*;

import java.util.List;

import org.junit.Test;

import com.smg.persistwork.aplicacio.model.AdministracionTest;
import com.smg.persistwork.aplicacio.model.EmpleadoTest;
import com.smg.persistwork.exception.PersistWorkException;
import com.smg.persistwork.model.mapeig.ObjecteMapejat;

public class ObjecteMapejatTest {

	@Test
	public void testObjecteMapejat() {
		EmpleadoTest e = new EmpleadoTest();
		try {
			ObjecteMapejat objmap = new ObjecteMapejat(e);
			assertNotNull(objmap);		
		} catch (PersistWorkException e1) {
			
			fail(e1.getMissatge());
		}
	}

	@Test
	public void testGetSqlInsert() {
		EmpleadoTest e = new EmpleadoTest();
		AdministracionTest a = new AdministracionTest();
		try {
			ObjecteMapejat objmap = new ObjecteMapejat(e);
			ObjecteMapejat objmapA = new ObjecteMapejat(a);
			assertNotNull(objmap);
			assertNotNull(objmapA);
			assertNotNull(objmap.getSqlInsert());	
			assertNotNull(objmapA.getSqlInsert());		
		} catch (PersistWorkException e1) {
			
			fail(e1.getMissatge());
		}
	}

	@Test
	public void testGetSqlDelete() {
		EmpleadoTest e = new EmpleadoTest();
		AdministracionTest a = new AdministracionTest();
		try {
			ObjecteMapejat objmap = new ObjecteMapejat(e);
			ObjecteMapejat objmapA = new ObjecteMapejat(a);
			assertNotNull(objmap);
			assertNotNull(objmapA);
			assertNotNull(objmap.getSqlDelete());	
			assertNotNull(objmapA.getSqlDelete());
		
		} catch (PersistWorkException e1) {
			
			fail(e1.getMissatge());
		}
	}

	@Test
	public void testGetSqlUpdate() {
		EmpleadoTest e = new EmpleadoTest();
		AdministracionTest a = new AdministracionTest();
		try {
			ObjecteMapejat objmap = new ObjecteMapejat(e);
			ObjecteMapejat objmapA = new ObjecteMapejat(a);
			assertNotNull(objmap);
			assertNotNull(objmapA);
			assertNotNull(objmap.getSqlUpdate());	
			assertNotNull(objmapA.getSqlUpdate());
	
		} catch (PersistWorkException e1) {
			
			fail(e1.getMissatge());
		}
	}

	@Test
	public void testGetSqlSelect() {
		EmpleadoTest e = new EmpleadoTest();
		AdministracionTest a = new AdministracionTest();
		try {
			ObjecteMapejat objmap = new ObjecteMapejat(e);
			ObjecteMapejat objmapA = new ObjecteMapejat(a);
			assertNotNull(objmap);
			assertNotNull(objmapA);
			assertNotNull(objmap.getSqlSelect());	
			assertNotNull(objmapA.getSqlSelect());
		
		} catch (PersistWorkException e1) {
			
			fail(e1.getMissatge());
		}
	}
	
	@Test
	public void getCreateSeqCP() {
		AdministracionTest a = new AdministracionTest();
		try {
			ObjecteMapejat objmap = new ObjecteMapejat(a);
			assertNotNull(objmap);
			assertNotNull(objmap.getCreateSeqCP());
		
			
		} catch (PersistWorkException e1) {
			// TODO Auto-generated catch block
			fail(e1.getMissatge());
		}
	}


	@Test
	public void testGetSqlCreate() {
		EmpleadoTest e = new EmpleadoTest();
		try {
			ObjecteMapejat objmap = new ObjecteMapejat(e);
			assertNotNull(objmap);
			assertNotNull(objmap.getSqlCreate());
		
		} catch (PersistWorkException e1) {
			// TODO Auto-generated catch block
			fail(e1.getMissatge());
		}
	}

	@Test
	public void testGetSqlCreateCP() {
		EmpleadoTest e = new EmpleadoTest();
		
		try {
			ObjecteMapejat objmap = new ObjecteMapejat(e);
		
			assertNotNull(objmap);
			assertNotNull(objmap.getSqlCreateCP());
			
		} catch (PersistWorkException e1) {
			// TODO Auto-generated catch block
			fail(e1.getMissatge());
		}
	}
	
	@Test
	public void testGetSqlCreateClauForanea() {
		EmpleadoTest e = new EmpleadoTest();
		AdministracionTest a = new AdministracionTest();
		try {
			ObjecteMapejat objmap = new ObjecteMapejat(e);
			ObjecteMapejat objmap2 = new ObjecteMapejat(a);
			
			assertNotNull(objmap);
			assertNotNull(objmap2);
			List<String> alters= objmap.getSqlCreateClausForaneas();
			assertNotNull(alters);
			assertNotSame(0,alters.size());
			for (String st : alters){
				assertNotNull(st);
				
			}
			
		} catch (PersistWorkException e1) {
			
			fail(e1.getMissatge());
		}
	}
}
