package com.smg.persistwork.model.annotations;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNotSame;
import static org.junit.Assert.assertTrue;

import java.lang.reflect.Field;

import org.junit.Test;

import com.smg.persistwork.aplicacio.model.EmpleadoTest;

public class ClauForaneaTest {

	@Test
	public void testNomIdRef() {
		EmpleadoTest e = new EmpleadoTest();
			
		for (Field f : e.getClass().getDeclaredFields()){
		
			if ( "admin".equals(f.getName() )){
										
				assertTrue(f.isAnnotationPresent(ClauForanea.class));
				ClauForanea c = f.getAnnotation(ClauForanea.class);
				assertNotNull(c.nomCamp());
			}
			
			if (!"admin".equals(f.getName())){
			
				assertFalse(f.isAnnotationPresent(ClauForanea.class));
			}			
			
		}
	}

	@Test
	public void testAgafaClau() {
		EmpleadoTest e = new EmpleadoTest();
	
		for (Field f : e.getClass().getDeclaredFields()){
		
			if ( "admin".equals(f.getName() )){							
				assertTrue(f.isAnnotationPresent(ClauForanea.class));
				ClauForanea cf = f.getAnnotation(ClauForanea.class);
				assertNotNull(cf.nomCamp());
				assertNotSame(0,  f.getType().getDeclaredFields().length);
			
				for (Field f2 : f.getType().getDeclaredFields()){
				
					if (f2.isAnnotationPresent(ClauPrimaria.class)){
					
						assertTrue(f2.isAnnotationPresent(Columna.class));
						Columna c = f2.getAnnotation(Columna.class);
						assertTrue(c.obligatori());
						assertEquals(12, c.tamany());
						ClauPrimaria cp = f2.getAnnotation(ClauPrimaria.class);
						assertEquals("SEQ_ADMIN_TEST",cp.nomSequencia());
						assertEquals(TipusClau.AUTO_INCREMENT, cp.tipusClau());
						assertEquals("int",f2.getType().getCanonicalName());
					
					}
					
				}
			}
			
			if (!"admin".equals(f.getName())){
				assertFalse(f.isAnnotationPresent(ClauForanea.class));
			}			
			
		}
	}

}
