/**
 * 
 */
package com.smg.persistwork.nucli;

import static org.junit.Assert.*;

import org.junit.Test;

import com.smg.persistwork.exception.PersistWorkException;
import com.smg.persistwork.nucli.ConfiguracioEntorn;

/**
 * @author Sergio Maeso
 * 
 */
public class ConfiguracioEntornTest {

	/**
	 * Test method for
	 * 
	 * .
	 */
	@Test
	public void testCreaConfiguracioStringString() {
		try {
			ConfiguracioEntorn.creaConfiguracio("bdEmpresa",
					"META-INF/fitxer-test.properties");
			
			ConfiguracioEntorn ce = ConfiguracioEntorn.getEntorn("bdEmpresa");
			assertNotNull(ce);
			assertNotNull(ce.getId());
			assertEquals("bdEmpresa", ce.getId());
			assertNotNull(ConfiguracioEntorn.getEntorn("bdEmpresa"));
			assertNotNull(ConfiguracioEntorn.getValorPropietat("bdEmpresa","persistwork.bd.tipus"));
			assertEquals("MYSQL", ConfiguracioEntorn.getValorPropietat("bdEmpresa","persistwork.bd.tipus"));
			assertNotSame("ORACLE", ConfiguracioEntorn.getValorPropietat("bdEmpresa","persistwork.bd.tipus"));

		} catch (PersistWorkException e) {

			fail(e.getMissatge());
		}

	}

	/**
	 * Test method for
	 * 
	 * .
	 */
	@Test
	public void testCreaConfiguracioString() {
		ConfiguracioEntorn ce;
		try {
			ConfiguracioEntorn.creaConfiguracio("bdEmpresaMySql");

			ce = ConfiguracioEntorn.getEntorn("bdEmpresaMySql");			
			assertNotNull(ce);
			assertNotNull(ce.getId());
			assertEquals("bdEmpresaMySql", ce.getId());
			assertNotNull(ConfiguracioEntorn.getEntorn("bdEmpresaMySql"));
			assertNotNull(ConfiguracioEntorn.getValorPropietat(
					"bdEmpresaMySql", "persistwork.bd.tipus"));
			assertEquals("ORACLE", ConfiguracioEntorn.getValorPropietat("persistwork.bd.tipus"));
			assertNotSame("MYSQL",
					ConfiguracioEntorn.getValorPropietat("persistwork.bd.tipus"));

		} catch (PersistWorkException e) {
			fail(e.getMissatge());
		}
	}

	/**
	 * Test method for
	 *
	 */
	@Test
	public void testCreaConfiguracio() {
		ConfiguracioEntorn ce;
		try {
			ConfiguracioEntorn.creaConfiguracio();

			ce = ConfiguracioEntorn.getEntorn();
			assertNotNull(ce);
			assertNotNull(ce.getId());
			assertEquals("ConfiguracioEntorn.ID", ce.getId());
			assertNotNull(ConfiguracioEntorn.getEntorn("ConfiguracioEntorn.ID"));
			assertNotNull(ConfiguracioEntorn
					.getValorPropietat("persistwork.bd.tipus"));
			assertEquals("ORACLE",
					ConfiguracioEntorn
							.getValorPropietat("persistwork.bd.tipus"));
			assertNotSame("MYSQL",
					ConfiguracioEntorn
							.getValorPropietat("persistwork.bd.tipus"));
		} catch (PersistWorkException e) {
			fail(e.getMissatge());
		}
	}

}
