package com.smg.persistwork.aplicacio.rrhh.accions;

import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;
import java.util.List;

import com.smg.persistwork.aplicacio.rrhh.model.Departament;
import com.smg.persistwork.aplicacio.rrhh.model.Empleat;
import com.smg.persistwork.exception.PersistWorkException;
import com.smg.persistwork.nucli.ManegadorEntitat;
import com.smg.persistwork.nucli.ManegadorEntitatFactory;

/**
 * @author Sergio Maeso
 *
 */
public class EmpleatAccio {

	/**
	 * 
	 */
	private ManegadorEntitat mng;
	
	/**
	 * @throws PersistWorkException
	 */
	public EmpleatAccio() throws PersistWorkException {
		super();
		mng = ManegadorEntitatFactory.createManegadorEntitat();
	}
	
	
	/**
	 * @param nom
	 * @param correu
	 * @param adreca
	 * @param cognom1 
	 * @param cognom2 
	 * @param dni 
	 * @param correu 
	 * @param adreca 
	 * @param dataEntradaEmpresa 
	 * @param dataNaixement 
	 * @param sou 
	 * @param idDept 
	 * @param numEmpleats
	 * @return
	 * @throws PersistWorkException
	 */
	public Empleat insertaEmpleat(String nom, String cognom1, String cognom2, String dni, String correu, String adreca, String dataEntradaEmpresa, String dataNaixement, String estudis, String sou, String idDept) throws PersistWorkException{
		
		
		if ("".equals(nom) || nom==null){
			throw new PersistWorkException(400, "El nom s obligatori");
		}
		
		if ("".equals(cognom1) || cognom1==null){
			throw new PersistWorkException(400, "El cognom1 s obligatori");
		}
		
		
		if ("".equals(dni) || dni==null){
			throw new PersistWorkException(400, "El dni s obligatori");
		}
		
	
		if ("".equals(dataEntradaEmpresa) || dataEntradaEmpresa==null){
			throw new PersistWorkException(400, "La dataEntradaEmpresa s obligatori");
		}
		
		if ("".equals(adreca) || adreca==null){
			throw new PersistWorkException(400, "L'adreca s obligatori");
		}
		
		if ("".equals(sou) || sou==null){
			throw new PersistWorkException(400, "El sou s obligatori");
		}
		double soud = 0;
		try{
			soud = Double.parseDouble(sou);
		} catch (NumberFormatException num){
			throw new PersistWorkException(400, "El sou ha de ser numric");
		}
		
		int iddpt = 0;
		try{
			iddpt = Integer.parseInt(idDept);
		} catch (NumberFormatException num){
			throw new PersistWorkException(400, "El departament de ser numric");
		}
			
		SimpleDateFormat form1 = new SimpleDateFormat("dd/MM/yyyy");
	
		GregorianCalendar calE = new GregorianCalendar();
		GregorianCalendar caln = new GregorianCalendar();
		try {
			calE.setTime(form1.parse(dataEntradaEmpresa));
			caln.setTime(form1.parse(dataNaixement));
		} catch (Exception e){
			throw new PersistWorkException(400, "El format de les dates s : dd/MM/yyyy");
		}
	
		Empleat emp = new Empleat();
		emp.setNom(nom);
		emp.setCognom1(cognom1);
		emp.setCognom2(cognom2);
		emp.setDni(dni);
		emp.setDataEntradaEmpresa(calE);
		emp.setDataNaixement(caln);
		emp.setSou(soud);
		emp.setEstudis(estudis);
		Departament dp = new Departament();
		dp.setId(iddpt);
		emp.setPertany(dp);
		emp.setCorreuElectronic(correu);
		emp.setAdreca(adreca);
	
		
		mng.inserta(emp);
		
		return emp;
	}
	
	
	/**
	 * @param nom
	 * @param correu
	 * @param adreca
	 * @param cognom1 
	 * @param cognom2 
	 * @param dni 
	 * @param correu 
	 * @param adreca 
	 * @param dataEntradaEmpresa 
	 * @param dataNaixement 
	 * @param sou 
	 * @param idDept 
	 * @param numEmpleats
	 * @return
	 * @throws PersistWorkException
	 */
	public Empleat guarda(String id, String nom, String cognom1, String cognom2, String dni, String correu, String adreca, String dataEntradaEmpresa, String dataNaixement, String estudis, String sou, String idDept) throws PersistWorkException{
		
		
		if ("".equals(id) || id==null){
			throw new PersistWorkException(400, "L'id  s obligatori");
		}
		
		if ("".equals(nom) || nom==null){
			throw new PersistWorkException(400, "El nom s obligatori");
		}
		
		if ("".equals(cognom1) || cognom1==null){
			throw new PersistWorkException(400, "El cognom1 s obligatori");
		}
		
		
		if ("".equals(dni) || dni==null){
			throw new PersistWorkException(400, "El dni s obligatori");
		}
		
	
		if ("".equals(dataEntradaEmpresa) || dataEntradaEmpresa==null){
			throw new PersistWorkException(400, "La dataEntradaEmpresa s obligatori");
		}
		
		if ("".equals(adreca) || adreca==null){
			throw new PersistWorkException(400, "L'adreca s obligatori");
		}
		
		if ("".equals(sou) || sou==null){
			throw new PersistWorkException(400, "El sou s obligatori");
		}
		double soud = 0;
		try{
			soud = Double.parseDouble(sou);
		} catch (NumberFormatException num){
			throw new PersistWorkException(400, "El sou ha de ser numric");
		}
		
		int iddpt = 0;
		try{
			iddpt = Integer.parseInt(idDept);
		} catch (NumberFormatException num){
			throw new PersistWorkException(400, "El id departament de ser numric");
		}
		
		int idE = 0;
		try{
			idE = Integer.parseInt(id);
		} catch (NumberFormatException num){
			throw new PersistWorkException(400, "El identificador de ser numric");
		}
			
		SimpleDateFormat form1 = new SimpleDateFormat("dd/MM/yyyy");
	
		GregorianCalendar calE = new GregorianCalendar();
		GregorianCalendar caln = new GregorianCalendar();
		try {
			calE.setTime(form1.parse(dataEntradaEmpresa));
			caln.setTime(form1.parse(dataNaixement));
		} catch (Exception e){
			throw new PersistWorkException(400, "El format de les dates s : dd/MM/yyyy");
		}
	
		Empleat emp = new Empleat();
		emp.setId(idE);
		emp.setNom(nom);
		emp.setCognom1(cognom1);
		emp.setCognom2(cognom2);
		emp.setDni(dni);
		emp.setDataEntradaEmpresa(calE);
		emp.setDataNaixement(caln);
		emp.setSou(soud);
		emp.setEstudis(estudis);
		Departament dp = new Departament();
		dp.setId(iddpt);
		emp.setPertany(dp);
		emp.setCorreuElectronic(correu);
		emp.setAdreca(adreca);
	
		
		mng.modifica(emp);
		
		return emp;
	}
	
	
	
	/**
	 * @return
	 * @throws PersistWorkException 
	 */
	public Empleat consulta(String id) throws PersistWorkException{
		
		int numemp = 0;
		try{
			numemp = Integer.parseInt(id);
			Empleat emp = new Empleat();
			emp.setId(numemp);
			return mng.consultaPerClau(emp);
		
		} catch (NumberFormatException num){
			throw new PersistWorkException(400, "L'identificador de l'empleat ha de ser numric");
		}
		
	}
	
	/**
	 * @return
	 * @throws PersistWorkException 
	 */
	public Empleat esborra(String id) throws PersistWorkException{
		
		int numemp = 0;
		try{
			numemp = Integer.parseInt(id);
			Empleat emp = new Empleat();
			emp.setId(numemp);
			mng.esborra(emp);
			return new Empleat();
		
		} catch (NumberFormatException num){
			throw new PersistWorkException(400,  "L'identificador de l'empleat ha de ser numric");
		}
		
	}
	
	/**
	 * @return
	 * @throws PersistWorkException
	 */
	public List<Empleat> cercaEmpleats() throws PersistWorkException{
		
		return mng.cercaTots(new Empleat());
	}
	
	/**
	 * @return
	 * @throws PersistWorkException
	 */
	public List<Empleat> cercaEmpleatsCamps(String nom, String cognom1, String dni) throws PersistWorkException{
		
		Empleat emp = new Empleat();
		if (!"".equals(nom))
			emp.setNom(nom);
		if (!"".equals(cognom1))
			emp.setCognom1(cognom1);
		if (!"".equals(dni))
			emp.setDni(dni);
		
		if ((nom==null || "".equals(nom))
			&&  (cognom1==null || "".equals(cognom1)) &&  (dni==null || "".equals(dni)))
			return cercaEmpleats();
		return mng.cerca(emp);
	}
	
}
