package com.smg.persistwork.aplicacio.rrhh.model;

import java.util.GregorianCalendar;

import com.smg.persistwork.model.annotations.ClauForanea;
import com.smg.persistwork.model.annotations.ClauPrimaria;
import com.smg.persistwork.model.annotations.Columna;
import com.smg.persistwork.model.annotations.Taula;
import com.smg.persistwork.model.annotations.TipusClau;

/**
 * @author Sergio Maeso
 *
 */
@Taula(nom="EMPLEATS_EMPRESA")
public class Empleat {

	@Columna(nom="NUM_EMPLEAT",obligatori=true,tamany=12)
	@ClauPrimaria(tipusClau=TipusClau.AUTO_INCREMENT,nomSequencia="SEQ_EMPLEATS")
	private int id;
	
	@Columna(obligatori=true,tamany=10)
	private String dni;
	
	@Columna(obligatori=true,tamany=30)
	private String nom;
	
	@Columna(obligatori=true,nom="PRIMER_COGNOM",tamany=60)
	private String cognom1;
	
	@Columna(nom="SEGON_COGNOM", tamany=60)
	private String cognom2;
	
	@Columna
	private GregorianCalendar dataNaixement;
	
	@Columna(tamany=150)
	private String correuElectronic;
	
	@Columna(tamany=300, obligatori=true, nom="DOMICILI_EMPLEAT")
	private String adreca;
	
	@Columna(obligatori=true, valorDefecte="SYSDATE")
	private GregorianCalendar dataEntradaEmpresa;
	
	@Columna(tamany=300)
	private String estudis;
	
	@Columna(tamany=10,precisio=2, obligatori=true, valorDefecte="0.0")
	private double sou;
	
	@ClauForanea(obligatori=false,nomCamp="ID_DEPARTAMENT",nomClauForana="FK_EMP_DPT")
	private Departament pertany;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getDni() {
		return dni;
	}

	public void setDni(String dni) {
		this.dni = dni;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getCognom1() {
		return cognom1;
	}

	public void setCognom1(String cognom1) {
		this.cognom1 = cognom1;
	}

	public String getCognom2() {
		return cognom2;
	}

	public void setCognom2(String cognom2) {
		this.cognom2 = cognom2;
	}

	public GregorianCalendar getDataNaixement() {
		return dataNaixement;
	}

	public void setDataNaixement(GregorianCalendar dataNaixement) {
		this.dataNaixement = dataNaixement;
	}

	public String getCorreuElectronic() {
		return correuElectronic;
	}

	public void setCorreuElectronic(String correuElectronic) {
		this.correuElectronic = correuElectronic;
	}

	public String getAdreca() {
		return adreca;
	}

	public void setAdreca(String adreca) {
		this.adreca = adreca;
	}

	public GregorianCalendar getDataEntradaEmpresa() {
		return dataEntradaEmpresa;
	}

	public void setDataEntradaEmpresa(GregorianCalendar dataEntradaEmpresa) {
		this.dataEntradaEmpresa = dataEntradaEmpresa;
	}

	public String getEstudis() {
		return estudis;
	}

	public void setEstudis(String estudis) {
		this.estudis = estudis;
	}

	public double getSou() {
		return sou;
	}

	public void setSou(double sou) {
		this.sou = sou;
	}

	public Departament getPertany() {
		return pertany;
	}

	public void setPertany(Departament pertany) {
		this.pertany = pertany;
	}
}
