package com.smg.persistwork.aplicacio.rrhh.model;

import java.util.GregorianCalendar;

import com.smg.persistwork.model.annotations.ClauForanea;
import com.smg.persistwork.model.annotations.ClauPrimaria;
import com.smg.persistwork.model.annotations.Columna;
import com.smg.persistwork.model.annotations.Taula;
import com.smg.persistwork.model.annotations.TipusClau;

/**
 * @author Sergio Maeso
 *
 */
@Taula
public class Projecte {

	
	@Columna(nom="ID_PROJECTE", obligatori=true,tamany=12)
	@ClauPrimaria(tipusClau=TipusClau.VALOR_ASSIGNAT)
	private String id;
	
	@Columna(obligatori=true,tamany=30)
	private String nom;
	
	@Columna(obligatori=true,tamany=300)
	private String descripcio;
	
	@Columna(valorDefecte="SYSDATE")
	private GregorianCalendar dataInici;
	
	@Columna
	private GregorianCalendar dataFi;
	
	@Columna(nom="SITUACIO_PROJECTE",obligatori=true,valorDefecte="ESBORRANY", tamany=30)
	private String estat;
	
	@Columna(tamany=10)
	private long horesValorades;
		
	@Columna(tamany=10)
	private int horesImputades;
	
	@ClauForanea(nomClauForana="FK_CAPPROJECTE",obligatori=true)
	private Empleat capProjecte;
	
	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public GregorianCalendar getDataInici() {
		return dataInici;
	}

	public void setDataInici(GregorianCalendar dataInici) {
		this.dataInici = dataInici;
	}

	public GregorianCalendar getDataFi() {
		return dataFi;
	}

	public void setDataFi(GregorianCalendar dataFi) {
		this.dataFi = dataFi;
	}

	public String getEstat() {
		return estat;
	}

	public void setEstat(String estat) {
		this.estat = estat;
	}

	public long getHoresValorades() {
		return horesValorades;
	}

	public void setHoresValorades(long horesValorades) {
		this.horesValorades = horesValorades;
	}

	public int getHoresImputades() {
		return horesImputades;
	}

	public void setHoresImputades(int horesImputades) {
		this.horesImputades = horesImputades;
	}

	public Empleat getCapProjecte() {
		return capProjecte;
	}

	public void setCapProjecte(Empleat capProjecte) {
		this.capProjecte = capProjecte;
	}	
	
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}
	
}
