package com.smg.persistwork.aplicacio.rrhh.model;

import com.smg.persistwork.model.annotations.ClauForanea;
import com.smg.persistwork.model.annotations.ClauPrimaria;
import com.smg.persistwork.model.annotations.Columna;
import com.smg.persistwork.model.annotations.Taula;
import com.smg.persistwork.model.annotations.TipusClau;

/**
 * @author Sergio Maeso
 *
 */
@Taula(nom="REL_PROJ_EMP")
public class ProjecteEmpleat {

	@Columna(obligatori=true,tamany=12)
	@ClauPrimaria(tipusClau=TipusClau.AUTO_INCREMENT,nomSequencia="SEQ_PRJEMPL")
	private int id;
	
	@ClauForanea(nomCamp="IDPROJ",obligatori=true,nomClauForana="FK_REL_PROJ")
	private Projecte projecte;
	
	@ClauForanea(nomCamp="IDEMPL",obligatori=true,nomClauForana="FK_REL_EMP")
	private Empleat empleat;
		
	@Columna(tamany=8,precisio=2)
	private double participacio;
	
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Projecte getProjecte() {
		return projecte;
	}

	public void setProjecte(Projecte projecte) {
		this.projecte = projecte;
	}

	public Empleat getEmpleat() {
		return empleat;
	}

	public void setEmpleat(Empleat empleat) {
		this.empleat = empleat;
	}

	public double getParticipacio() {
		return participacio;
	}

	public void setParticipacio(double participacio) {
		this.participacio = participacio;
	}


}
